
# Утилита для работы с устройствами семейства "Алтей" через Modbus

## 1. Структура каталогов
- Lib - вспомогательные библиотеки;
  - libmodbus - библиотека, реализующая протокол Modbus;
  - tclap - библиотека для обработки параметров командной строки;
- Project - файлы проекта для Visual Studio 2019;
- Source - исходный текст программы;
  - BZP - подкаталог, содержащий файлы, специфичиные для устройства "Алтей-БЗП";
    - KIWIDatabaseIDs.h - определения идентификаторов сигналов, уставок и пр. для
                          устройства "Алтей-БЗП";
  - OZT - подкаталог, содержащий файлы, специфичиные для устройства "Алтей-ОЗТ";
    - KIWIDatabaseIDs.h - определения идентификаторов сигналов, уставок и пр. для
                          устройства "Алтей-ОЗТ";
  - UZT - подкаталог, содержащий файлы, специфичиные для устройства "Алтей-УЗТ";
    - KIWIDatabaseIDs.h - определения идентификаторов сигналов, уставок и пр. для
                          устройства "Алтей-УЗТ";
  - ByteOrderingConverter - функции преобразования внутреннего представления 
                            многобайтовых чисел;
  - main.cpp - основной модуль, содержащий функцию main(), обработку командной строки
               и реализацию прикладной функциональности;
  - ModbusFunction65 - клиентская реализация функции 65 Modbus.

## 2. Примеры использования утилиты
**1. Получение списка осциллограмм**

    AlteyModbusClient.exe --osclist --port COM7 --baud 38400 --address 1

**2. Скачивание осциллограммы в несжатом виде**

    AlteyModbusClient.exe --getosc --oscnumber 1 --local osc1.cff --compression 0 --port COM7 --baud 38400 --address 1

**3. Скачивание осциллограммы в сжатом виде**

    AlteyModbusClient.exe --getosc --oscnumber 1 --local osc1.cff --compression 3 --port COM7 --baud 38400 --address 1

Для распаковки осциллограммы, скачанной в сжатом виде, можно воспользоваться утилитой zpipe из библиотеки zlib 
(https://www.zlib.net/).

**4. Скачивание записей журнала событий**

    AlteyModbusClient.exe --eventlog --firstrec 0 --records 10 --port COM7 --baud 38400 --address 1

**5. Скачивание записей журнала сообщений**

    AlteyModbusClient.exe --msglog --firstrec 0 --records 10 --port COM7 --baud 38400 --address 1

**6. Скачивание записей журнала изменений уставок**

    AlteyModbusClient.exe --setlog --firstrec 0 --records 10 --port COM7 --baud 38400 --address 1
