﻿/**
 * @file
 * @brief Содержит реализацию модуля @ref ByteOrderingConverter "ByteOrderingConverter".
 */

#include <stdint.h>
#include "ByteOrderingConverter.h"

/**
 * @addtogroup ByteOrderingConverter
 * @{
 */

/*====================================== ПРОТОТИПЫ ФУНКЦИЙ ======================================*/

static void* convertValueInSitu(uint8_t* pValue, uint8_t numberOfBytes);

/*=========================================== ФУНКЦИИ ===========================================*/

uint16_t* boc_convert16BitValueInSitu(void* p16BitValue)
{
	return (uint16_t*)convertValueInSitu((uint8_t*)p16BitValue, 2);
}
/*-----------------------------------------------------------------------------------------------*/
uint32_t* boc_convert32BitValueInSitu(void* p32BitValue)
{
	return (uint32_t*)convertValueInSitu((uint8_t*)p32BitValue, 4);
}
/*-----------------------------------------------------------------------------------------------*/
uint64_t* boc_convert64BitValueInSitu(void* p64BitValue)
{
	return (uint64_t*)convertValueInSitu((uint8_t*)p64BitValue, 8);
}
/*-----------------------------------------------------------------------------------------------*/
void* convertValueInSitu(uint8_t* pValue, uint8_t numberOfBytes)
{
	for (uint8_t i = 0; i < numberOfBytes / 2; i++)
	{
		uint8_t j = numberOfBytes - i - 1;
		uint8_t temp = pValue[i];
		pValue[i] = pValue[j];
		pValue[j] = temp;
	}

	return pValue;
}
/*-----------------------------------------------------------------------------------------------*/

/*@}*/
