﻿/**
 * @file
 * @brief Содержит объявления констант, типов и функций модуля 
 *        @ref ByteOrderingConverter "ByteOrderingConverter".
 */

#ifndef APPLICATION_USER_UTILITIES_BYTEORDERINGCONVERTER_H_
#define APPLICATION_USER_UTILITIES_BYTEORDERINGCONVERTER_H_

#include <stdint.h>

#ifdef __cplusplus
extern "C"
{
#endif

/**
 * @defgroup ByteOrderingConverter Модуль ByteOrderingConverter
 *
 * Этот модуль реализует преобразователь порядка байтов в многобайтовых числах.
 */
/*@{*/

/*===================================== ПРОТОТИПЫ ФУНКЦИЙ =======================================*/

uint16_t* boc_convert16BitValueInSitu(void* p16BitValue);
/*-----------------------------------------------------------------------------------------------*/
uint32_t* boc_convert32BitValueInSitu(void* p32BitValue);
/*-----------------------------------------------------------------------------------------------*/
uint64_t* boc_convert64BitValueInSitu(void* p64BitValue);
/*-----------------------------------------------------------------------------------------------*/

/*@}*/

#ifdef __cplusplus
}
#endif

#endif /* APPLICATION_USER_UTILITIES_BYTEORDERINGCONVERTER_H_ */
